;
;  Version:  %'1.3'
;
;  Copyright 1999-2003 Altium BV
;
$CASE
	
;
;
	NAME _STUB

	PUBLIC	__LK_STUB_ENTRY

EXTRN	CODE(__LK_FUNCTION_ADDRESS)
EXTRN	DATA(__LK_FUNCTION_BANK)

%IFNDEF(ARIT_UNIT)THEN(
%DEFINE(ARIT_UNIT)(0)
)FI
	
%IF(%EQS(%ARIT_UNIT,DALLAS_AA))THEN(
	BANK_SFR	EQU	AP
)ELSE(
	%IFDEF (CPU_c51f12x) THEN (
		BANK_SFR	EQU	PSBANK
	) ELSE (
		BANK_SFR	EQU	P1
	) FI
)FI

;************************************************************************
;									*
;		__LK_STUB						*
;									*
;	This routine is inserted for every CALL from one segment to a	*
;	segment in another bank. The variable __LK_FUNCTION_ADDRESS	*
;	will be resolved with the 16-bit offset of the called label.	*
;									*
;************************************************************************

__LK_STUB SEGMENT CODE
	RSEG	__LK_STUB
__LK_STUB_ENTRY:
	MOV	DPTR,#__LK_FUNCTION_ADDRESS
	JMP	__LK_BANKSWITCH


;************************************************************************
;									*
;		__BANKSW						*
;									*
;	This routine takes care of the actual switching of code-banks.			*
;	This will depend on the hardware implementation. By default			*
;	the example uses the SFR P1 to select the code bank. This is			*
;	the method supported by the Crossview Pro Simulator. In case			*
;	of the Dallas DS80c390 the SFR AP is used for bank switching. 		*
;	In case of the Cygnal C8051F124 the SFR PSBANK is used.			*
;									*
;************************************************************************

__BANKSW	SEGMENT	CODE
	RSEG	__BANKSW
__LK_BANKSWITCH:
	PUSH	BANK_SFR			; push current bank
	CALL	_bankswitch
	POP	BANK_SFR			; switch back to original bank
	RET

_bankswitch:
	MOV	BANK_SFR,#__LK_FUNCTION_BANK	; switch to new bank
	PUSH	DPL
	PUSH	DPH
	RET


;************************************************************************
;									*
;		__LK_STUB	METHOD 2				*
;									*
;	This method should not be used anymore. Reason is that it	*
;	required the accumulator. This conflicts with some runtime	*
;	routines that also require the accumulator for parameter        *
;	passing! See PR22459.						*
;									*
;************************************************************************

	END
